package com.braintree.customersupportbackoffice.handler;

import com.hybris.cockpitng.dataaccess.facades.object.exceptions.ObjectSavingException;
import com.hybris.cockpitng.engine.WidgetInstanceManager;
import com.hybris.backoffice.editorarea.BackofficeEditorAreaLogicHandler;
import com.hybris.cockpitng.util.notifications.NotificationService;
import com.hybris.cockpitng.util.notifications.event.NotificationEvent;
import de.hybris.platform.core.model.BraintreeGeneralConfigurationModel;
import de.hybris.platform.core.model.BraintreeSRCConfigurationModel;

public class BraintreeSRCConfigurationLogicHandler extends BackofficeEditorAreaLogicHandler {

    public static final String SRC_CONFIGURATION_DISABLED = "srcConfigurationDisabled";
    private static final String SRC_ACCOUNT_LIMITATION_DISABLED = "srcAccountLimitationDisabled";

    private NotificationService notificationService;

    @Override
    public Object performSave(WidgetInstanceManager widgetInstanceManager, Object currentObject) throws ObjectSavingException {
        BraintreeSRCConfigurationModel braintreeSRCConfigurationModel = (BraintreeSRCConfigurationModel) currentObject;
        if (!braintreeSRCConfigurationModel.isEnabled()) {
            notificationService.notifyUser(widgetInstanceManager, SRC_CONFIGURATION_DISABLED,
                    NotificationEvent.Level.INFO);
        }
        return super.performSave(widgetInstanceManager, currentObject);
    }

    @Override
    public void beforeEditorAreaRender(WidgetInstanceManager widgetInstanceManager, Object currentObject) {
        BraintreeSRCConfigurationModel braintreeSRCConfigurationModel = (BraintreeSRCConfigurationModel) currentObject;
        final BraintreeGeneralConfigurationModel generalConfigurationModel = braintreeSRCConfigurationModel.getPluginConfiguration()
                .getBraintreeGeneralConfiguration();;
        if (!braintreeSRCConfigurationModel.isEnabled()) {
            notificationService.notifyUser(widgetInstanceManager, SRC_CONFIGURATION_DISABLED,
                    NotificationEvent.Level.WARNING);
        }
        if (generalConfigurationModel.isDropIn()) {
            notificationService.notifyUser(widgetInstanceManager, SRC_ACCOUNT_LIMITATION_DISABLED,
                    NotificationEvent.Level.WARNING);
        }
        super.beforeEditorAreaRender(widgetInstanceManager, currentObject);
    }

    public void setNotificationService(NotificationService notificationService) {
        this.notificationService = notificationService;
    }
}
